HDU 2514--Another Eight Puzzle【DFS】

来源:互联网 发布:政府集中采购流程 知乎 编辑:程序博客网 时间:2024/05/18 22:44

Another Eight Puzzle

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 861    Accepted Submission(s): 544


Problem Description
Fill the following 8 circles with digits 1~8,with each number exactly once . Conntcted circles cannot be filled with two consecutive numbers.
There are 17 pairs of connected cicles:
A-B , A-C, A-D
B-C, B-E, B-F
C-D, C-E, C-F, C-G
D-F, D-G
E-F, E-H
F-G, F-H
G-H

Filling G with 1 and D with 2 (or G with 2 and D with 1) is illegal since G and D are connected and 1 and 2 are consecutive .However ,filling A with 8 and B with 1 is legal since 8 and 1 are not consecutive .

In this problems,some circles are already filled,your tast is to fill the remaining circles to obtain a solution (if possivle).
 

Input
The first line contains a single integer T(1≤T≤10),the number of test cases. Each test case is a single line containing 8 integers 0~8,the numbers in circle A~H.0 indicates an empty circle.

 

Output
For each test case ,print the case number and the solution in the same format as the input . if there is no solution ,print “No answer”.If there more than one solution,print “Not unique”.
 

Sample Input
37 3 1 4 5 8 0 07 0 0 0 0 0 0 01 0 0 0 0 0 0 0
 

Sample Output
Case 1: 7 3 1 4 5 8 6 2Case 2: Not uniqueCase 3: No answer
 

题意:图中a, b, c, d, e, f, g, h的位置的值只能为1-8的数,输入8个数,相邻的不能是连续的数(即绝对值不能为1), 有些数是0,将为0的填成1-8中未使用的数。

如果只有一种情况,输出它,

如果有多种情况,输出:Not unique

如果没有符合条件的情况,输出:No answer


#include <cstdio>#include <cstring>#include <cmath>int a[10];int b[10];int vis[10];int ans;int check(){if (abs(a[2]-a[1])!=1&&        abs(a[3]-a[1])!=1&&        abs(a[4]-a[1])!=1&&        abs(a[2]-a[3])!=1&&        abs(a[2]-a[5])!=1&&        abs(a[2]-a[6])!=1&&        abs(a[3]-a[4])!=1&&        abs(a[3]-a[5])!=1&&        abs(a[3]-a[6])!=1&&        abs(a[3]-a[7])!=1&&        abs(a[4]-a[6])!=1&&        abs(a[4]-a[7])!=1&&        abs(a[5]-a[6])!=1&&        abs(a[5]-a[8])!=1&&        abs(a[6]-a[7])!=1&&        abs(a[6]-a[8])!=1&&        abs(a[7]-a[8])!=1        )        return 1;    else return 0;}void dfs(int k){    int i;if(k==9){if(check()){ans++;if(ans==1){for(i=1;i<=8;++i)b[i]=a[i];}}return ;}if(ans>=2) return ;if(a[k]) dfs(k+1);else {for(i=1;i<=8;++i)if(!vis[i]){a[k]=i;vis[i]=1;dfs(k+1);//回溯a[k]=0;vis[i]=0;}}}int main (){int t,i;int con=1;scanf("%d",&t);while(t--){memset(vis,0,sizeof(vis));for(i=1;i<=8;++i){scanf("%d",&a[i]);vis[a[i]]=1;}printf("Case %d: ",con++);ans=0;dfs(1);if(ans==1){            for(i=1;i<8;++i)                printf("%d ",b[i]);            printf("%d\n",b[8]);}else if(ans==0) printf("No answer\n");else printf("Not unique\n");}return 0;}


0 0
原创粉丝点击